<?php
/*********************************************************************
*@filename CsvBase.php
*@description 
*@note
*@histories  rivision	author		date		comment
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy        2009/07/09   modify for YBR-37
********************************************************************/
require_once( '../models/group.php' );
$csv_folder=ROOT.DS.APP_DIR.DS."tmp".DS."csv".DS;
//$body=preg_replace('/\\\/','\\\\\\', $csv_folder);
define( 'CSV_FOLDER', $csv_folder);
        
//require_once("CsvBaseUtil.php");
class CsvBase  {
  //共通コラム
 public $common_cols = array(
//			     "Group/id"=>"グループID",
//			     "Group/group_name"=>"グループ名",
////			     "Useproc/host_id"=>"ホストID",
//			     "Host/host_name"=>"クライアントPC名",
			     
			     );
 public $common_search_title=array(
//                                    ""=>"□ 検索条件", 
//                                    "dt_check/start_year start_month start_day"=>"開始日", 
//                                    "dt_check/end_year end_month end_day"=>"終了日", 
//                                    "dt_check/start_hour start_min end_hour end_min"=>"一日毎の時間指定", 
//                                    "dt_check/week"=>"曜日指定", 
                                    
                                    );
// public $report=array($this->set_str_encoding("□ レポート"));
// public $common_search_title1=array(
// 									"",
//									"□ レポート",
//                                   
//                                    );
  public $sql="";

  
  
  //データ取得






//  public function getData($type = 0){
//    $db = DB_Factory::create("acompany");
//    if(strlen(trim($this->sql))>0){
//      $sql = $this->getSql($this->sql);
//    }else{
//      $sql = $this->getSql($type);
//    }
//    $rows = $db->execute($sql);
//    if(count($this->data)>0)
//      {
//	$rows=$this->data;
//      }
//    
//    if(count($rows)>0)
//      {
//	for($i=0;$i<count($rows);$i++)
//	  {
//	    if(count($rows[$i])>0)
//	      {
//		foreach($rows[$i] as $key=>$value)
//		  {
//		    $rows[$i][$key]=mb_convert_encoding($value,"SJIS","UTF-8");
//		  }
//	      }
//	  }
//      }
//    return $rows;
//  }
  
  //CSVタイトル取得






  public function getCsvTitle(){

    $cols = array_merge($this->common_cols,$this->special_cols);
	
   	
    foreach($cols as $key=>$value){	  
        $title[] = $this->set_str_encoding($value);
    }
      
    return $title;
  }
//検索条件の取得






    public function getSearchTitle()
    {
        $title = array_merge($this->common_search_title,$this->special_search_title);
		
        foreach($title as $key=>$value){	  
            $title[$key] = $this->set_str_encoding($value);
        }
        return $title;
    }
    public function getSearchWhere($info,$rows)
    {
//        echo "<pre>";
//        var_dump($info);exit;
        $title=$this->getSearchTitle();
        foreach ($title as $key=> $value)
        {
            //xuwc 2007/08/10 9:33 begin
            //if(strlen($key)==0)
            if(strlen($key)==0||is_numeric($key))
            //xuwc 2007/08/10 9:33 end
            {
                $data[$key][]=$value;
            }else{
                $data[$key][]=$value;
                list($model,$name)=explode("/",$key);
                $keys=explode(" ",$name);
//                echo "<pre>";
//                var_dump($keys);
                if($keys[0]=="start_year"||$keys[0]=="end_year")
                {
                    $data[$key][]=$info[$model][$keys[0]]."-".$info[$model][$keys[1]]."-".$info[$model][$keys[2]];
                }elseif($keys[0]=="start_hour")
                {
                    $data[$key][]=$info[$model][$keys[0]].":".$info[$model][$keys[1]]."～".$info[$model][$keys[2]].":".$info[$model][$keys[3]];
                }else{
                    if($keys[0]=="group_name")
                    {
                       
                        //xuwc 2007/08/11 begin
                        
                        $group=new Group();
                        $groupnames=$group->Group->findAll(array("Group.id=".$info[$model]['group']),"Group.group_name");
                         
                        //xuwc 2007/08/11 end
                        $data[$key][]=$groupnames[0]['Group']['group_name'];
                    }elseif($keys[0]=="week"){
//                        echo "<pre>";
//                        var_dump($info[$model]);exit;
                        for($i=0;$i<count($info[$model][$keys[0]]);$i++)
                        {
                            $week.=$this->getWeek($info[$model][$keys[0]][$i])." ";
                        }
                        $data[$key][]=$week;
                    }
                    else{
                        empty($info[$model][$keys[0]])?$data[$key][]="":$data[$key][]=$info[$model][$keys[0]];
                    }
                }
            }
        }
        //xuwc 2007/07/17 begin
        foreach($data as $key=>$value){	 
            $results=array();
            for($i=0;$i<count($value);$i++)
            { 
                if(!empty($value[1]) && $i==1)
                {
                    $results[]= $this->set_str_encoding($value[$i]);
                }else{
                    $results[]=$value[$i];
                }
            }
            $data[$key]=$results;
        }
        //xuwc 2007/07/17 end
        return $data;
//        echo "<pre>";
//        var_dump($data);exit;
    }
    public function getWeek($week)
    {
//        echo $week;exit;
        switch ($week)
        {
            case 'Monday':
                $result="月";
                break;
            case 'Tuesday':
                $result="火";
                break;
            case 'Wednesday':
                $result="水";
                break;
            case 'Thursday':
                $result="木";
                break; 
             case 'Friday':
                $result="金";
                break;
             case 'Saturday':
                $result="土";
                break;
             case 'Sunday':
                $result="日";
                break;
        }
        return $result;
    }
  //CSV COL 取得






  public function getCsvCol(){    
    if(count($this->common_cols)>0)
 
     {
        foreach($this->common_cols as $key=> $value)
        {
            $colist = split(" ",$key);
    
            $newkey="";
            for($i=0;$i<count($colist);$i++)
            {
                $newkey.=$colist[$i];
            }
    //        $newkey=substr($newkey,0,-1);
            $newarray[$newkey]=$value;
    
        }
    }else{
         $newarray=array();
    }
    
    $cols = array_merge($newarray,$this->special_cols);

    foreach($cols as $key=>$value){
    	
        $collist[] = $key;
    }
	

    return $collist;
  }
  
  
 

  //各特別処理






    public function doSpeci($colname,$row){  
                   
        if(count($row)>0)
        {  
            $keys=explode("/",$colname);
            if(count($keys)> 1)
            {
                $key=$keys[0];
                if (array_key_exists($key,$row) && array_key_exists($keys[1],$row[$key])){  
                    
                    //	$str = spec_util($colname,$row[$colname]);
                    $str = $row[$key][$keys[1]];
//                    echo "<pre>";
//                    var_dump($row);exit;
                }else{
                    echo $colname." 処理未実装/Data 存在しない";
                    exit;    
//                    $colist = split(" ",$colname);
//                    //	$str = $colname; 
//                    $str="";
//                    foreach($colist as $col){
//                        if(array_key_exists($col,$row)){
//                        //modify by sunj 2007-1-17 19:41
//                        //	    $str=$str." ".str_replace($col,spec_util($col,$row[$col]),$str);
//                            $str=$str." ".str_replace($col,spec_util($col,$row[$col]),$col);
//                        }else{
//                            if ($col != "FLAG"){
//                              echo $col." 処理未実装/Data 存在しない";
//                              exit;      
//                            }
//                        }
//                    }
                }
          }else{
            $str="";
          }
        }else{
          $str="";
        }
        return $str;
  }

  //CSVファイルダウンロード






  public function sendCSVFile($rows,$info,$name,$encrypt=""){  
 
    //一時ファイル作成　BEGIN
    $filename = substr(md5(time().rand(0,1000000)),0,30) . ".csv";

    $fp = fopen(CSV_FOLDER.$filename, 'w');    
    //xuwc 2007/10/11 begin
//    if($encrypt=='encrypt')
//    {
//        $rand=rand(10000000,99999999);
//        //$rand=11111111;
//        $rands[]=$rand;
//        fputcsv($fp,$rands);
//        //echo $tmp."@@".$rand;exit;
//    }
    //xuwc 2007/10/11 end
    //xuwc 2007/06/26 15:02 begin
    $searchList=$this->getSearchWhere($info,$rows); 

    foreach ($searchList as $key=> $value)
    {
        fputcsv($fp,$value,",");
    }
	
    for($i=0;$i<count($this->common_search_title1);$i++)
    {
//		echo "1111";
		$this->common_search_title1[$i]=$this->set_str_encoding($this->common_search_title1[$i]);
        fputcsv($fp,array($this->common_search_title1[$i]));
    }
//    echo "<pre>";
//    var_dump($searchList);exit;
    //xuwc 2007/06/26 15:02 end
    
    fputcsv($fp,$this->getCsvTitle());
    //TITLE END
    $cols = $this->getCsvCol();
//    echo "<pre>";
//    var_dump($cols);exit;
//    $rows = $this->getData();
//    foreach($cols as $key=>$value){
//    	$cols[$key]=strtoupper($value);
//    }
    //xuwc 2007/10/11 暗号化begin
    if($encrypt=='encrypt')
    {
        foreach($rows as $row){  
            
            $data=array();    
            foreach($cols as $col){	
                //$tmp=$this->decrypt("R-X#U-P*","63662719");
//                $xuwc=$this->decrypt($this->set_str_encoding(trim($this->doSpeci($col,$row))),$rand);
//                $xuwc1=$this->
                //zhangs start 20080318
                $rowdata_1 = substr(trim($this->doSpeci($col,$row)),-1);
                if($rowdata_1 == '\\'){
                	$rowdata_1 = substr(trim($this->doSpeci($col,$row)),0,-1);
                }else{
                	$rowdata_1 = trim($this->doSpeci($col,$row));
                }
                
                if($col=='Host/password')
                {
                    $data[] = "$$".$this->set_str_encoding($rowdata_1);	  
                }else{
                    $data[] = $this->set_str_encoding($rowdata_1);	  
                }
            }
    //       
//    echo "<pre>";
//    var_dump($data);exit;
          fputcsv($fp,$data,",");
        }	
    }else{
        foreach($rows as $row){  
            
            $data=array();    
            foreach($cols as $col){	
            	$rowdata_2 = substr(trim($this->doSpeci($col,$row)),-1);
                if($rowdata_2 == '\\'){
                	$rowdata_2 = trim($this->doSpeci($col,$row)).'\\';
                }else{
                	$rowdata_2 = trim($this->doSpeci($col,$row));
                }
                $data[] = $this->set_str_encoding($rowdata_2);	  
            }
    //        echo "<pre>";
    //        var_dump($data);exit;
    //zhangs end 20080318
          fputcsv($fp,$data,",");
        }	
    }     
    //xuwc 2007/10/11 暗号化end
    fclose($fp);
    //一時ファイル作成　END

    //ファイルダウンロード BEGIN
    require_once( 'HTTP/Download.php' );
    //sunhy start 2009/07/09 modify for YBR-37
    //$dfname = $this->set_str_encoding($name).date("Ymdhis",time()).".csv";
    $dfname = $this->set_str_encoding($name).date("YmdHis",time()).".csv";
    //sunhy end 2009/07/09 modify for YBR-37
    $dl = &new HTTP_Download();
    $dl->setFile(CSV_FOLDER.$filename);
    //$dl->setContentDisposition(HTTP_DOWNLOAD_ATTACHMENT, $dfname);
	$dl->setContentDisposition(HTTP_DOWNLOAD_ATTACHMENT, $name.date("YmdHis",time()).".csv");
    $dl->setContentType('application/vnd.ms-excel');
    $dl->send();
    //ファイルダウンロード END
    
    //一時ファイル削除
     //
//      $csvfolder=CSV_FOLDER ;
//     echo $filename ;exit;
//    echo "<pre>";
 
//     var_dump(glob(CSV_FOLDER."/*.*"));

//    echo count(glob(CSV_FOLDER."/*.*"))."@@";exit;
//     echo   (is_writable(CSV_FOLDER.$filename))?  ' @@@@@@@@@@@@@'  :   '****************';exit;
    if(count(glob(CSV_FOLDER."*.*")) > 0)
 
    {
        foreach (glob(CSV_FOLDER."*.*") as $filename)
        {
             
                unlink($filename);
            
        }
    }

      //
//    unlink(CSV_FOLDER.$filename);
    exit;
  }
//暗号化




function keyED($txt,$encrypt_key) 
{ 
    $encrypt_key = md5($encrypt_key); 
    $ctr=0; 
    $tmp = ""; 
    for ($i=0;$i<strlen($txt);$i++) 
    { 
        if ($ctr==strlen($encrypt_key)) $ctr=0; 
        $tmp.= substr($txt,$i,1) ^ substr($encrypt_key,$ctr,1); 
        $ctr++; 
    } 
    return $tmp; 
} 

function encrypt($txt,$key) 
{ 
    srand((double)microtime()*1000000); 
    $encrypt_key = md5(rand(0,32000)); 
    $ctr=0; 
    $tmp = ""; 
    for ($i=0;$i<strlen($txt);$i++) 
    { 
        if ($ctr==strlen($encrypt_key)) $ctr=0; 
        $tmp.= substr($encrypt_key,$ctr,1) . 
        (substr($txt,$i,1) ^ substr($encrypt_key,$ctr,1)); 
        $ctr++; 
    } 
    return $this->keyED($tmp,$key); 
} 

function decrypt($txt,$key) 
{ 
    $txt = $this->keyED($txt,$key); 
    $tmp = ""; 
    for ($i=0;$i<strlen($txt);$i++) 
    { 
        $md5 = substr($txt,$i,1); 
        $i++; 
        $tmp.= (substr($txt,$i,1) ^ $md5); 
    } 
    return $tmp; 
} 


  //DIR 削除
  function remove_directory($dir) {
    if ($handle = opendir("$dir")) {
      while (false !== ($item = readdir($handle))) {
	if ($item != "." && $item != "..") {
	  if (is_dir("$dir/$item")) {
	    remove_directory("$dir/$item");
	  } else {
	    unlink("$dir/$item");
	  }
	}
      }
      closedir($handle);
      rmdir($dir);
    }
  }


  // 全角空白削除 BEGIN
  function removeJPBlank($str){
    $str = trim($str);
    $str = str_replace("　", "\t", $str);
    $str = trim($str,'\t');
    return trim($str);    
  }
   function set_str_encoding($name)
    {
    	//xushanning start 2009/04/22   modify for LogvillageChinese
        //$result= mb_convert_encoding($name,"SJIS","UTF-8"); 
        $result= mb_convert_encoding($name,__('CharacterSet',$retrun=true),"UTF-8"); 
        //xushanning start 2009/04/22   modify for LogvillageChinese
        return $result;
    } 
}

?>